
#ifndef DVBRC_H
#define DVBRC_H

#define DVB_S	1
#define DVB_T	2
#define DVB_C	3

#define MAX_PIDS 	8

struct lnb_s {
	unsigned int		id, type, diseqcnr;
	unsigned long		lof1, lof2, slof;
};

struct satellite_s {
	unsigned int		id, lnbid;
	char			*name;
	unsigned long		fmin, fmax;
	struct lnb_s		*lnb;
};

struct transmitter_t {  /* Never used. */
	unsigned int		id;
	char			*name;
};

struct transponder_s {
	unsigned int		id, type, satid;
	char			pol;
	char			*fec;
	unsigned long		freq, srate;
	struct satellite_s	*satellite;
};

struct transponder_t {
	unsigned int		id;
	unsigned long		freq;	/* frequency */
	struct transmitter_t	*transmitter;
	unsigned int		bandw;	/* Bandwidth */
#if 0
	/* FIXME - can't save this in a char, needs two values each */
	unsigned char		crh	/* code rate high */
	unsigned char		crl	/* code rate low */
#endif
	unsigned int		modul;	/* Modulation */
	unsigned int		trans;	/* Transmission */
	unsigned int		guard;	/* Guard interval */
	signed int		hier;	/* hierarchy */
};

struct transponder {
	char			type;
	union {
		struct transponder_s	s;
		struct transponder_t	t;
		/* struct transponder_c	c; */ /* not implemented yet */
	} tp;
};

struct channel {
	struct channel *	next;
	unsigned int		id;
	char			*name;
	unsigned int		ppid;	/* "Programm Map Table" Pid */
	unsigned int		pids;
	unsigned int		pid[MAX_PIDS];
	unsigned int		ptype[MAX_PIDS];
	unsigned int		sid;
	unsigned int		type;
	unsigned int		ttpid;
	struct transponder *	transponder;
};

struct dvbrc {
	struct channel *	chans;
};

/* Global variables */
extern struct dvbrc *	dvbrc;

/* Function declarations */
int read_dvbrc(char * fn);
struct channel * get_channel_by_id(unsigned int cid);

#endif /* DVBRC_H */
